=== debian/changelog ===
s390-tools (2.40.0-2) unstable; urgency=medium

  * QA upload.

  [ Aurelien Jarno ]
  * Remove Build-Depends: gcc-multilib (Closes: #1125247)

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 27 Jan 2026 23:22:08 +0100

s390-tools (2.40.0-1) unstable; urgency=medium

  * QA upload.

  [ Andreas Tille ]
  * Maintain package in Debian team on Salsa
  * Fix Homepage
  * d/watch: version=5
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Rebase patches to new upstream version

  [ Pranav P ]
  * Changes for new upstream version

 -- Pranav P <pranav.p7@ibm.com>  Thu, 15 Jan 2026 16:21:12 +0100

s390-tools (2.35.0-2) unstable; urgency=medium

  * Remove Build-Depends: libfuse-dev, already B-Ds libfuse3-dev
    (Closes: #1084411)
  * Fix FTBFS with gcc-15 using upstream patch (Closes: #1121190)

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 22 Nov 2025 14:47:51 +0000
