=== debian/control ===
Source: s390-tools
Standards-Version: 4.7.3
Maintainer: Debian QA Group <packages@qa.debian.org>
Section: admin
Build-Depends:
 debhelper-compat (= 13),
 libz-dev,
 libglib2.0-dev,
 libfuse3-dev,
 libncurses-dev,
 libpfm4-dev,
 libssl-dev,
 libcurl4-openssl-dev,
 libcryptsetup-dev,
 libjson-c-dev,
 libxml2-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnl-route-3-dev,
Vcs-Browser: https://salsa.debian.org/debian/s390-tools
Vcs-Git: https://salsa.debian.org/debian/s390-tools.git
Homepage: https://github.com/ibm-s390-linux/s390-tools
Rules-Requires-Root: no

Package: s390-tools
Architecture: s390x
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 gawk,
Recommends:
 sg3-utils,
Description: Set of fundamental utilities for Linux on S/390
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-udeb
Architecture: s390x
Section: debian-installer
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Package-Type: udeb
Description: Set of utilities for Linux on S/390
 This is a minimal package used by debian-installer.
 This package contains only the binaries dasdfmt and fdasd.

Package: ziomon
Architecture: s390x
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 blktrace,
 rsync,
Recommends:
 multipath-tools,
 lsscsi,
Description: Performance analysis and reports for zFCP devices
 Tool set to collect data from zFCP devices for performance analysis
 and reporting.
