=== debian/watch ===
Version: 5

Template: Github
Owner: ibm-s390-linux
Project: s390-tools
